package ueb092wuerfel;

import processing.core.*;

@SuppressWarnings("serial")
public class Ueb092Wuerfel extends PApplet {

	private float radX = 2.66f;
	private float radY = 0.77f;
	private float radZ = 0f;
	//private int z = 0;
	private int zoom = 75;

	private PImage eins;
	private PImage zwei;
	private PImage drei;
	private PImage vier;
	private PImage fuenf;
	private PImage sechs;

	private int imgWidth;
	private int imgHeight;

	public void setup() {
		size(400, 400, OPENGL);
		//fill(220);
		strokeWeight(3);
		// noStroke();
		
		

		eins = loadImage("1.gif");
		zwei = loadImage("2.gif");
		drei = loadImage("3.gif");
		vier = loadImage("4.gif");
		fuenf = loadImage("5.gif");
		sechs = loadImage("6.gif");

		// alle Bilder sind gleich gross
		imgWidth = eins.width;
		imgHeight = eins.height;
	}

	public void draw() {
		background(255);
		// zentrieren
		translate(width / 2, height / 2);

		// skalierung, faktor 50 vergrssern
		scale(zoom);
		
		//lights();
		pointLight(255, 255, 255, -100, -50, 200);

		rotateX(radX); // rotiert das objekt
		rotateY(radY); // rotiert das objekt
		rotateZ(radZ); // rotiert das objekt

		// 1. Seite | Front
		beginShape(QUADS);
		tint(255, 0, 0);
		texture(eins);
		vertex(-1, -1, 1, 0, 0); // top-left
		vertex(1, -1, 1, imgWidth, 0); // top-right
		vertex(1, 1, 1, imgWidth, imgHeight); // bottom-right
		vertex(-1, 1, 1, 0, imgHeight); // bottom-left
		endShape(CLOSE);

		// 2. Seite | Rechts
		beginShape(QUADS);
		tint(0, 255, 0);
		texture(fuenf);
		vertex(1, -1, 1, 0, 0); // top-right
		vertex(1, -1, -1, imgWidth, 0);
		vertex(1, 1, -1, imgWidth, imgHeight);
		vertex(1, 1, 1, 0, imgHeight); // bottom-right
		endShape(CLOSE);

		// 3. Seite | Links
		beginShape(QUADS);
		tint(0, 0, 255);
		texture(zwei);
		vertex(-1, -1, 1, 0, 0); // top-left
		vertex(-1, -1, -1, imgWidth, 0);
		vertex(-1, 1, -1, imgWidth, imgHeight);
		vertex(-1, 1, 1, 0, imgHeight); // bottom-left
		endShape(CLOSE);

		// 4. Seite | Hinten
		beginShape(QUADS);
		tint(255, 255, 0);
		texture(sechs);
		vertex(-1, -1, -1, 0, 0); // hinten-top-left
		vertex(1, -1, -1, imgWidth, 0);
		vertex(1, 1, -1, imgWidth, imgHeight);
		vertex(-1, 1, -1, 0, imgHeight); // hinten-bottom-left
		endShape(CLOSE);

		// 5. Seite | Oben
		beginShape(QUADS);
		tint(255, 0, 255);
		texture(drei);
		vertex(-1, -1, 1, 0, 0); // top-left
		vertex(1, -1, 1, imgWidth, 0); // top-right
		vertex(1, -1, -1, imgWidth, imgHeight);
		vertex(-1, -1, -1, 0, imgHeight);
		endShape(CLOSE);

		// 6. Seite | Unten
		beginShape(QUADS);
		tint(0, 255, 255);
		texture(vier);
		vertex(-1, 1, 1, 0, 0); // bottom-left
		vertex(1, 1, 1, imgWidth, 0); // bottom-right
		vertex(1, 1, -1, imgWidth, imgHeight);
		vertex(-1, 1, -1, 0, imgHeight);
		endShape(CLOSE);
	}

	public void mouseDragged() {
		radX = (float) mouseY / (width / 2) * PI;
		radY = (float) mouseX / (height / 2) * PI;
		// radZ = (float)mouseX/(height/2)*PI;
	}

	public void keyPressed() {
		if (key == 'r') {
			radX = 2.66f;
			radY = 0.77f;
			radZ = 0;
		} else if (key == '+') {
			zoom += 5;
			if (zoom > 100)
				zoom = 100;
		} else if (key == '-') {
			zoom -= 5;
			if (zoom < 5)
				zoom = 5;
		}
	}

}
